
/* Esercizio 1bis di Esercizidel30-5-17 
 Stesso esercizio che in 1 di Esercizidel30-5-17 ma utilizzando uno stato
 concreto con un accesso diretto al last della coda. Complessit\`a della
 remove costante invece che lineare (come in MuQueueADTX).
 Ci sono altri problemi: Ad ogni add/remove dovremmo propagare i valori 
 corretti di size e di last su tutti i componenti (ma dobbiamo visitare 
 l'intera struttura e questo ci porta ad un costo analogo a quelo ella 
 soluzione di Esercizio 1).
 Soluzione di compromesso: Aggiorniamo size e last solo nel primo compo-
 nente. Gli altri componenti hanno campi size e last non significativi.
 Tuttavia quando il calcolo con tali componenti interni richiede il valore
 effettivo della size e del last defininiamo le operazioni private realSize
 e realLast in grado di calcolari i valori richiesti.
 Una queue e' un valore con le seguenti operazioni specifiche:
	add per aggiungere un elemento alla coda
	get per accedere il primo tra gli inseriti, non ancora rimossi
	remove per rimuovere il primo tra gli inseriti, non ancora rimossi
	size per conoscere quanti elementi sono ancora in coda
	empty per conoscere se la coda ha elementi
 Si chiede di:
 (b) Definire un ADT, MuQueueADTXV.java, per l'API, MuQueueAPI<A>,
     vedi Esercizio 1;
 (c) Definire gli additionals;
 (d) Fornire AF e I  per MuQueueADTXV.java; */

import java.util.*;
import java.lang.*;

/* (b,c) */
public class MuQueueADTXV<A> implements MuQueueAPI<A>{
	private A first;
    private MuQueueADTXV<A> rest;
    private MuQueueADTXV<A> last;
	private int size;
	//metodi
	public MuQueueADTXV(){//for introducing empty qu
		size = 0;
	}
    private MuQueueADTXV(A x, MuQueueADTXV<A> r,
                          MuQueueADTXV<A> l, int n){
        first = x; rest = r; last = l; size =n;
    }
    public void add(A x){//n e last sono significative solo al first item
		if (first == null){first = x; size = 1; return;}
        if (rest == null) {
            rest = new MuQueueADTXV<A>(x,null,null,0);
            last = rest;
            size = 2;
            return;
        }
        MuQueueADTXV<A> newLast =
                        new MuQueueADTXV<A>(x,null,null,0);
        last.rest = newLast;
        last = newLast;
		size = size+1;
	}
	public A get(){//restituisce null se vuota
		return first;
	}
	public void remove(){
		if (size == 0) throw new Error();
        if (size == 1) {first = null; size = 0; return;}
        if (size == 2) {first = rest.first; rest = null;
                        last = null; size = 1; return;}
        first = rest.first;
        rest = rest.rest;
        size = size - 1;//last is unchanged
	}
	public int size(){		
		return realSize();
	}
    private int realSize(){
        if (first == null) return 0;
        if (rest == null) return 1;
        return 1 + rest.realSize();
    }
	public boolean empty(){		
		return (first == null);
	}
	
	//additionals
	//equals ereditata da Object
    
    private MuQueueADTXV<A> realLast(){//to be used in clone
        if (rest == null) return null;
        if (rest.rest == null) return rest;
        return rest.realLast();
        
    }
	public MuQueueADTXV<A> clone(){//here, complications due to the
                                   //sharing of the component Last
		MuQueueADTXV<A> ret = new MuQueueADTXV<A>();
		ret.first = first;
		ret.rest = (rest==null)?null:rest.clone();
        ret.last = (ret.rest==null)?null:ret.rest.realLast();
		ret.size = size;
		return ret;
	}
	public String toString(){
		if (first == null) return "[]";
		String first = this.first.toString();
		if (rest == null) return ("["+first+"]");
		String rest = this.rest.toString();
		rest = rest.substring(1,rest.length()-1);
		return ("["+first+","+rest+"]");
	}
	public LinkedList<A> elements(){//wrong: to be modified
		return null;
	}
	
}

/* (d)
 Sia [MuQueueADTXV<Ta>]={[v1,...,vk] | (forall i\[1..k]) vi\in[Ta], Ta\in[A]},
 l'insieme dei valori astratti definiti da MuQueueADTX<Ta>, dove v1 e' first 
 ed e' il primo elemento inserito e non rimosso.
 AF(c) = [] if c.realSize() = 0
 AF(c) = [v1,...,vk] if (c.realSize() = k) & (k > 0) & c.first = v1
						& AF(c.rest) = [v2,...,vk] 
 I(c) = if (c.realSize() = 0) then (c.first = null & c.rest = null)
        & if (c.realSize = 1) then (c.first != null & c.rest = null)
        & if (c.realSize() > 1) then c.realSize() = c.rest.realSize()+1
 */


/* (e) */
 
class MainV{
    public static void main(String[] args) throws Error{
        MuQueueADTXV<Integer> queue1 = new MuQueueADTXV<Integer>();
		queue1.add(1);
		queue1.add(5);
        System.out.println("queue1.get() = " + queue1.get());
        System.out.println("queue1 = " + queue1.toString());
		MuQueueADTXV<Integer> queue2 = queue1;
		MuQueueADTXV<Integer> clone1 = queue1.clone();
		queue2.add(12);
		System.out.println("queue1 = " + queue1.toString());		
		System.out.println("queue2 = " + queue2.toString());		
		System.out.println("clone1 = " + clone1.toString());
		clone1.remove();
		clone1.remove();
		System.out.println("queue1 = " + queue1.toString());		
		System.out.println("queue2 = " + queue2.toString());		
		System.out.println("clone1 = " + clone1.toString());
		clone1.add(7);
		clone1.add(6);
		System.out.println("queue1 = " + queue1.toString());		
		System.out.println("queue2 = " + queue2.toString());		
		System.out.println("clone1 = " + clone1.toString());
	}
}

/*
 etruria-wifi-217-70:ZcodeMQAX marcob$ cd ..
 etruria-wifi-217-70:JavaSoluzioni marcob$ javac MuQueueADTX.java 
 MuQueueADTXV.java -d ZcodeMQAX/
 etruria-wifi-217-70:JavaSoluzioni marcob$ cd ZcodeMQAX/
 etruria-wifi-217-70:ZcodeMQAX marcob$ java MainV
 queue1.get() = 1
 queue1 = [1,5]
 queue1 = [1,5,12]
 queue2 = [1,5,12]
 clone1 = [1,5]
 queue1 = [1,5,12]
 queue2 = [1,5,12]
 clone1 = []
 queue1 = [1,5,12]
 queue2 = [1,5,12]
 clone1 = [7,6]
 etruria-wifi-217-70:ZcodeMQAX marcob$
 */ 

/* (f) to be done */
 
